/* apps/pem_mail.c */
/* Copyright (C) 1995 Eric Young (eay@mincom.oz.au)
 * All rights reserved.
 * 
 * This file is part of an SSL implementation written
 * by Eric Young (eay@mincom.oz.au).
 * The implementation was written so as to conform with Netscapes SSL
 * specification.  This library and applications are
 * FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
 * as long as the following conditions are aheared to.
 * 
 * Copyright remains Eric Young's, and as such any Copyright notices in
 * the code are not to be removed.  If this code is used in a product,
 * Eric Young should be given attribution as the author of the parts used.
 * This can be in the form of a textual message at program startup or
 * in documentation (online or textual) provided with the package.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *    This product includes software developed by Eric Young (eay@mincom.oz.au)
 * 
 * THIS SOFTWARE IS PROVIDED BY ERIC YOUNG ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * 
 * The licence and distribution terms for any publically available version or
 * derivative of this code cannot be changed.  i.e. this code cannot simply be
 * copied and put under another distribution licence
 * [including the GNU Public Licence.]
 */

#include <stdio.h>
#include "x509.h"
#include "x509_obj.h"
#include "err.h"
#include "pem.h"

char *usage[]={
"usage: x509 args\n",
"\n",
" -in arg         - input file - default stdin\n",
" -out arg        - output file - default stdout\n",
" -cert arg       - the certificate to use\n",
" -key arg        - the private key to use\n",
" -sign           - sign the message\n",
" -enc arg        - encrypt with one of cbc-des\n",
NULL
};

int main(argc, argv)
int argc;
char **argv;
	{
	FILE *in;
	X509 *x=NULL;
	RSA *rsa=NULL;
	PEM_CTX ctx;
	unsigned int i,n;
	unsigned char buf[1024*10];
	unsigned char buff[1024*10];

	ERR_load_crypto_strings();

	in=fopen("/home/eay/lib/rsa/eay1024.pem","r");
	if (in == NULL)
		{
		perror("open");
		exit(1);
		}
	x=X509_new();
	if (!PEM_read_X509(in,x))
		{
		ERR_print_errors(stderr);
		exit(1);
		}
	fclose(in);

	in=fopen("/home/eay/lib/rsa/eay1024.pem","r");
	if (in == NULL)
		{
		perror("open");
		exit(1);
		}
	rsa=RSA_new();
	if (!PEM_read_RSA(in,rsa)) goto err;
	fclose(in);


	PEM_SignInit(&ctx,NID_md5);
	for (;;)
		{
		i=fread(buf,1,1024*10,stdin);
		if (i <= 0) break;
		if (!PEM_SignUpdate(&ctx,buf,i)) goto err;
		}
	if (!PEM_SignFinal(&ctx,buf,&n,rsa)) goto err;
	PEM_bin2ascii(n,buf,buff);
	fprintf(stderr,"%s\n",buff);
	exit(0);
err:
	ERR_print_errors(stderr);
	exit(1);
	}
